#include "../../pmu-events/pmu-events.h"
struct pmu_event pme_cavium[] = {
{
	.name = "l1d_cache_rd",
	.event = "event=0x40",
	.desc = "L1D cache read",
	.topic = "thunderx2 imp def",
	.long_desc = "Attributable Level 1 data cache access, read",
},
{
	.name = "l1d_cache_wr",
	.event = "event=0x41",
	.desc = "L1D cache write",
	.topic = "thunderx2 imp def",
	.long_desc = "Attributable Level 1 data cache access, write ",
},
{
	.name = "l1d_cache_refill_rd",
	.event = "event=0x42",
	.desc = "L1D cache refill read",
	.topic = "thunderx2 imp def",
	.long_desc = "Attributable Level 1 data cache refill, read",
},
{
	.name = "l1d_cache_refill_wr",
	.event = "event=0x43",
	.desc = "L1D refill write",
	.topic = "thunderx2 imp def",
	.long_desc = "Attributable Level 1 data cache refill, write",
},
{
	.name = "l1d_tlb_refill_rd",
	.event = "event=0x4c",
	.desc = "L1D tlb refill read",
	.topic = "thunderx2 imp def",
	.long_desc = "Attributable Level 1 data TLB refill, read",
},
{
	.name = "l1d_tlb_refill_wr",
	.event = "event=0x4d",
	.desc = "L1D tlb refill write",
	.topic = "thunderx2 imp def",
	.long_desc = "Attributable Level 1 data TLB refill, write",
},
{
	.name = "l1d_tlb_rd",
	.event = "event=0x4e",
	.desc = "L1D tlb read",
	.topic = "thunderx2 imp def",
	.long_desc = "Attributable Level 1 data or unified TLB access, read",
},
{
	.name = "l1d_tlb_wr",
	.event = "event=0x4f",
	.desc = "L1D tlb write",
	.topic = "thunderx2 imp def",
	.long_desc = "Attributable Level 1 data or unified TLB access, write",
},
{
	.name = "bus_access_rd",
	.event = "event=0x60",
	.desc = "Bus access read",
	.topic = "thunderx2 imp def",
	.long_desc = "Bus access read",
},
{
	.name = "bus_access_wr",
	.event = "event=0x61",
	.desc = "Bus access write",
	.topic = "thunderx2 imp def",
	.long_desc = "Bus access write",
},
{
	.name = 0,
	.event = 0,
	.desc = 0,
},
};
struct pmu_event pme_cortex_a53[] = {
{
	.name = "stall_sb_full",
	.event = "event=0xc7",
	.desc = "Data Write operation that stalls the pipeline because the store buffer is full",
	.topic = "pipeline",
},
{
	.name = "other_iq_dep_stall",
	.event = "event=0xe0",
	.desc = "Cycles that the DPU IQ is empty and that is not because of a recent micro-TLB miss, instruction cache miss or pre-decode error",
	.topic = "pipeline",
},
{
	.name = "ic_dep_stall",
	.event = "event=0xe1",
	.desc = "Cycles the DPU IQ is empty and there is an instruction cache miss being processed",
	.topic = "pipeline",
},
{
	.name = "iutlb_dep_stall",
	.event = "event=0xe2",
	.desc = "Cycles the DPU IQ is empty and there is an instruction micro-TLB miss being processed",
	.topic = "pipeline",
},
{
	.name = "decode_dep_stall",
	.event = "event=0xe3",
	.desc = "Cycles the DPU IQ is empty and there is a pre-decode error being processed",
	.topic = "pipeline",
},
{
	.name = "other_interlock_stall",
	.event = "event=0xe4",
	.desc = "Cycles there is an interlock other than  Advanced SIMD/Floating-point instructions or load/store instruction",
	.topic = "pipeline",
},
{
	.name = "agu_dep_stall",
	.event = "event=0xe5",
	.desc = "Cycles there is an interlock for a load/store instruction waiting for data to calculate the address in the AGU",
	.topic = "pipeline",
},
{
	.name = "simd_dep_stall",
	.event = "event=0xe6",
	.desc = "Cycles there is an interlock for an Advanced SIMD/Floating-point operation",
	.topic = "pipeline",
},
{
	.name = "ld_dep_stall",
	.event = "event=0xe7",
	.desc = "Cycles there is a stall in the Wr stage because of a load miss",
	.topic = "pipeline",
},
{
	.name = "st_dep_stall",
	.event = "event=0xe8",
	.desc = "Cycles there is a stall in the Wr stage because of a store",
	.topic = "pipeline",
},
{
	.name = "bus_access_ld",
	.event = "event=0x60",
	.desc = "Bus access - Read",
	.topic = "memory",
},
{
	.name = "bus_access_st",
	.event = "event=0x61",
	.desc = "Bus access - Write",
	.topic = "memory",
},
{
	.name = "ext_mem_req",
	.event = "event=0xc0",
	.desc = "External memory request",
	.topic = "memory",
},
{
	.name = "ext_mem_req_nc",
	.event = "event=0xc1",
	.desc = "Non-cacheable external memory request",
	.topic = "memory",
},
{
	.name = "bus_access_ld",
	.event = "event=0x60",
	.desc = "Bus access - Read",
	.topic = "bus",
},
{
	.name = "bus_access_st",
	.event = "event=0x61",
	.desc = "Bus access - Write",
	.topic = "bus",
},
{
	.name = "ext_mem_req",
	.event = "event=0xc0",
	.desc = "External memory request",
	.topic = "bus",
},
{
	.name = "ext_mem_req_nc",
	.event = "event=0xc1",
	.desc = "Non-cacheable external memory request",
	.topic = "bus",
},
{
	.name = "exc_irq",
	.event = "event=0x86",
	.desc = "Exception taken, IRQ",
	.topic = "other",
},
{
	.name = "exc_fiq",
	.event = "event=0x87",
	.desc = "Exception taken, FIQ",
	.topic = "other",
},
{
	.name = "pre_decode_err",
	.event = "event=0xc6",
	.desc = "Pre-decode error",
	.topic = "other",
},
{
	.name = "l1i_cache_err",
	.event = "event=0xd0",
	.desc = "L1 Instruction Cache (data or tag) memory error",
	.topic = "other",
},
{
	.name = "l1d_cache_err",
	.event = "event=0xd1",
	.desc = "L1 Data Cache (data, tag or dirty) memory error, correctable or non-correctable",
	.topic = "other",
},
{
	.name = "tlb_err",
	.event = "event=0xd2",
	.desc = "TLB memory error",
	.topic = "other",
},
{
	.name = "prefetch_linefill",
	.event = "event=0xc2",
	.desc = "Linefill because of prefetch",
	.topic = "cache",
},
{
	.name = "prefetch_linefill_drop",
	.event = "event=0xc3",
	.desc = "Instruction Cache Throttle occurred",
	.topic = "cache",
},
{
	.name = "read_alloc_enter",
	.event = "event=0xc4",
	.desc = "Entering read allocate mode",
	.topic = "cache",
},
{
	.name = "read_alloc",
	.event = "event=0xc5",
	.desc = "Read allocate mode",
	.topic = "cache",
},
{
	.name = "ext_snoop",
	.event = "event=0xc8",
	.desc = "SCU Snooped data from another CPU for this CPU",
	.topic = "cache",
},
{
	.name = "br_indirect_spec",
	.event = "event=0x7a",
	.desc = "Branch speculatively executed - Indirect branch",
	.topic = "branch",
},
{
	.name = "br_cond",
	.event = "event=0xc9",
	.desc = "Conditional branch executed",
	.topic = "branch",
},
{
	.name = "br_indirect_mispred",
	.event = "event=0xca",
	.desc = "Indirect branch mispredicted",
	.topic = "branch",
},
{
	.name = "br_indirect_mispred_addr",
	.event = "event=0xcb",
	.desc = "Indirect branch mispredicted because of address miscompare",
	.topic = "branch",
},
{
	.name = "br_cond_mispred",
	.event = "event=0xcc",
	.desc = "Conditional branch mispredicted",
	.topic = "branch",
},
{
	.name = 0,
	.event = 0,
	.desc = 0,
},
};
struct pmu_events_map pmu_events_map[] = {
{
	.cpuid = "0x00000000420f5160",
	.version = "v1",
	.type = "core",
	.table = pme_cavium
},
{
	.cpuid = "0x00000000410fd03[[:xdigit:]]",
	.version = "v1",
	.type = "core",
	.table = pme_cortex_a53
},
{
	.cpuid = 0,
	.version = 0,
	.type = 0,
	.table = 0,
},
};
